import java.io.IOException;
import java.util.List;

import com.gnostice.pdfone.PdfDocument;
import com.gnostice.pdfone.PdfException;
import com.gnostice.pdfone.PdfRenderErrorHandler;
import com.gnostice.pdfone.PdfSearchMode;
import com.gnostice.pdfone.PdfSearchOptions;

public class SearchDemo implements PdfRenderErrorHandler
{
    public static void main(String[] args) throws IOException,
        PdfException
    {
    	try
    	{
	        PdfDocument d = new PdfDocument();
	        
	        d.load(args[0]);
	        
	        d.setRenderErrorHandler(new SearchDemo());
	
	        // Literal string search with case sensitive and whole word only options set
//	        List searchResults = d.search("Text", 1, PdfSearchMode.LITERAL, PdfSearchOptions.WHOLE_WORD | PdfSearchOptions.CASE_SENSITIVE);
	        
	        // Literal/Normal search 
	        List searchResults = d.search("Text", 1, PdfSearchMode.LITERAL, PdfSearchOptions.NONE);
	        
	        // Regex expression for phone number search
	        // Ex: searches for the phone numbers in the format for instanceof (+91)9302304240
//	        List searchResults = d.search("\\(\\+\\d{2}\\)\\d{10}", 1, PdfSearchMode.REGEX, PdfSearchOptions.NONE);
	        
	        // Regex expression for email search in the format email@email.com
//	        List searchResults = d.search(1, "^[\\w\\.\\-]+\\@[\\w\\.\\-]+\\.[\\w\\.\\-]+$", PdfSearchMode.REGEX, PdfSearchOptions.NONE);
	        
	        if (searchResults.isEmpty())
	        {
	            System.out.println("0 matche(s) found");
	        }
	        else
	        {
	            System.out.println(searchResults.size() + " matche(s) found");
	        }
	        
	        for(int i = 0; i < searchResults.size(); i++)
	        {
	            System.out.println(searchResults.get(i));
	        }
	        
	        d.close();
    	}
    	catch(ArrayIndexOutOfBoundsException ex)
    	{
    		System.out.println("Usage : java SearchDemo "
                    + "<input file path>");
    	}
    }

    public void onRenderError(Object sender, Throwable throwable)
    {
        throwable.printStackTrace();
    }
}
